package com.nisum.webfluxreactivemongodb.repository;

import com.nisum.webfluxreactivemongodb.dto.ProductDto;
import com.nisum.webfluxreactivemongodb.entity.Product;
import org.springframework.data.domain.Range;
import org.springframework.data.mongodb.repository.ReactiveMongoRepository;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public interface ProductRepository extends ReactiveMongoRepository<Product, Integer> {

    Mono<Product> findByName(String name);

    Mono<Product> findByQuantity(int quantity);

    Mono<Product> findByPrice(double price);

    Flux<ProductDto> findByPriceBetween(Range<Double> closed);
}
