package com.nisum.webfluxreactivemongodb.service;

import com.nisum.webfluxreactivemongodb.dto.ProductDto;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public interface ProductService {

    Mono<ProductDto> saveProduct(Mono<ProductDto> productDto);

    Mono<ProductDto> getProduct(int id);

    Flux<ProductDto> getAllProducts();

    Mono<ProductDto> updateProduct(Mono<ProductDto> productDto, int id);

    Mono<Void> deleteProduct(int id);

    Mono<ProductDto> getProductByName(String name);

    Mono<ProductDto>getProductByQuantity(int quantity);

    Mono<ProductDto> getProductByPrice(double price);

    Flux<ProductDto> getProductInRange(double min, double max);
}

